//https://bl.ocks.org/mbostock/2368837

import {
  select,
  csv,
  scaleLinear,
  max,
  scaleBand,
  axisLeft,
  axisRight,
  axisBottom,
  format,
  extent,
  ascending,
} from 'd3';

var margin = {top: 30, right: 10, bottom: 50, left: 50},
    width = 500,
    height = 300;

//https://stackoverflow.com/questions/46205118/how-to-sort-a-d3-bar-chart-based-on-an-array-of-objects-by-value-or-key
const render = data => {
  
data.sort(function(a, b) {return ascending(a.value, b.value)})

var svg = select('svg')
						.append('svg')
						.attr('width', width + margin.left + margin.right)
						.attr('height', height + margin.top + margin.bottom).append('g')
						.attr('transform', 'translate(' + margin.left + ',' + margin.top + ')');
  
// set the ranges
var y = scaleBand()
    .range([height, 0])
    .padding(0.2);

var x = scaleLinear()
    .range([0, width]);

// Scale the range of the data in the domains
x.domain(d3.extent(data, function (d) {return d.value}));
y.domain(data.map(function (d) {return d.dataset}));
  
// add the x Axis 
//https://stackoverflow.com/questions/18474620/d3-js-tickformat-adding-a-sign-without-multiplying-by-100

  
var procentTick = svg
		.append("g")
		.attr("class", "xaxis")
    .attr("transform", "translate(0," + height + ")")
		.call(xAxis)
		.select('.domain').remove();

const xAxisLabelText = "Hier gaat het goed!";
const xAxisLabelTextTwee = "Hier valt er winst te behalen";
  
svg.append('text')
    .attr('class', 'axis-label')
    .attr('y', 335)
    .attr('x', -10)
    .attr('fill', 'black')
    .text(xAxisLabelText);
  
svg.append('text')
    .attr('class', 'axistwee-label')
    .attr('y', 335)
    .attr('x', 330)
    .attr('fill', 'black')
    .text(xAxisLabelTextTwee);

//https://bl.ocks.org/stevenwmarks/c23bf3940bc5f1ee4027ccc72097a03b
//namen links of rechts zetten
var tickNeg = svg
				.append("g")
				.attr("class", "yaxis")
				.attr("transform", "translate(" + x(0) + ",0)")
				.call(axisLeft(y))
				.selectAll(".tick")
				.filter(function(d, i) { return data[i].value < 0; });

tickNeg.select("line")
			.attr("x2", 6)
			
tickNeg.select("text")
			.attr("x", 9)
			.style("text-anchor", "start");		
  
// append the rectangles for the bar chart
svg.selectAll(".bar")
    .data(data)
    .enter().append("rect")
    .attr("class", function (d) {return "bar bar--" + (d.value < 0 ? "negative" : "positive")})
    .attr("x", function (d) {return x(Math.min(0, d.value))})
    .attr("y", function (d) {return y(d.dataset)})
    .attr("width", function (d) {return Math.abs(x(d.value) - x(0))})
    .attr("height", y.bandwidth());
  
};

csv('data.csv').then(data => {
  data.forEach(d => {
    d.value = +d.value;
  });
  
render(data);
  });